<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – How To Work with Data Queries</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="how-to-work-with-data-queries">How To Work with Data Queries</h1>
<p>During the past few weeks as I've made various SNMP Data Query templates I've ran into a few 'tricks' (which existing user scripts use) to make them work with most devices. It'd probably be beneficial to publish these in some manner on the documentation site so others don't have to stumble.</p>
<p>As you already know getting an index is the hardest thing users struggle with. I've ran across three scenarios and their solutions:</p>
<h2 id="snmp-index-is-present">SNMP index is present</h2>
<p>Basically mimic the interface.xml template which comes with Cacti <code>(cacti/resource/snmp_queries/interface.xml)</code>.</p>
<p>SNMPWALK:</p>
<pre class="console"><code>Raw OIDs:
.1.3.6.1.2.1.2.2.1.1.1 = INTEGER: 1
.1.3.6.1.2.1.2.2.1.1.2 = INTEGER: 2
.1.3.6.1.2.1.2.1.0 = INTEGER: 2
</code></pre>
<pre class="console"><code>Textual MIB names:
IF-MIB::ifIndex.1 = INTEGER: 1
IF-MIB::ifIndex.2 = INTEGER: 2
IF-MIB::ifNumber.0 = INTEGER: 2
</code></pre>
<p>In the SNMP XML file, specify the <code>&lt;oid_index&gt;</code> and optional <code>&lt;oid_num_indexes&gt;</code> fields. For example:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode XML"><code class="sourceCode xml"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">&lt;interface&gt;</span></a>
<a class="sourceLine" id="cb3-2" title="2">    <span class="kw">&lt;name&gt;</span>Get SNMP Interfaces<span class="kw">&lt;/name&gt;</span></a>
<a class="sourceLine" id="cb3-3" title="3">    <span class="kw">&lt;description&gt;</span>Queries a host for a list of monitorable interfaces<span class="kw">&lt;/description&gt;</span></a>
<a class="sourceLine" id="cb3-4" title="4">    <span class="kw">&lt;oid_index&gt;</span>.1.3.6.1.2.1.2.2.1.1<span class="kw">&lt;/oid_index&gt;</span></a>
<a class="sourceLine" id="cb3-5" title="5">    <span class="kw">&lt;oid_num_indexes&gt;</span>.1.3.6.1.2.1.2.1.0<span class="kw">&lt;/oid_num_indexes&gt;</span></a>
<a class="sourceLine" id="cb3-6" title="6"></a>
<a class="sourceLine" id="cb3-7" title="7">    <span class="kw">&lt;fields&gt;</span></a>
<a class="sourceLine" id="cb3-8" title="8">        <span class="kw">&lt;ifIndex&gt;</span></a>
<a class="sourceLine" id="cb3-9" title="9">            <span class="kw">&lt;name&gt;</span>Index<span class="kw">&lt;/name&gt;</span></a>
<a class="sourceLine" id="cb3-10" title="10">            <span class="kw">&lt;method&gt;</span>walk<span class="kw">&lt;/method&gt;</span></a>
<a class="sourceLine" id="cb3-11" title="11">            <span class="kw">&lt;source&gt;</span>value<span class="kw">&lt;/source&gt;</span></a>
<a class="sourceLine" id="cb3-12" title="12">            <span class="kw">&lt;direction&gt;</span>input<span class="kw">&lt;/direction&gt;</span></a>
<a class="sourceLine" id="cb3-13" title="13">            <span class="kw">&lt;oid&gt;</span>.1.3.6.1.2.1.2.2.1.1<span class="kw">&lt;/oid&gt;</span></a>
<a class="sourceLine" id="cb3-14" title="14">        <span class="kw">&lt;/ifIndex&gt;</span></a>
<a class="sourceLine" id="cb3-15" title="15">    <span class="kw">&lt;/fields&gt;</span></a>
<a class="sourceLine" id="cb3-16" title="16"><span class="kw">&lt;/interface&gt;</span></a></code></pre></div>
<p>A verbose query from inside Cacti shows the following:</p>
<pre class="shell"><code>+ Running data query [1].
+ Found type = &#39;3&#39; [snmp query].
+ Found data query XML file at &#39;C:/Inetpub/wwwroot/cacti/resource/snmp_queries/interface.xml&#39;
+ XML file parsed ok.
+ Executing SNMP walk for list of indexes @ &#39;.1.3.6.1.2.1.2.2.1.1&#39;
+ Index found at OID: &#39;iso.3.6.1.2.1.2.2.1.1.1&#39; value: &#39;1&#39;
+ Index found at OID: &#39;iso.3.6.1.2.1.2.2.1.1.2&#39; value: &#39;2&#39;
+ Located input field &#39;ifIndex&#39; [walk]
+ Executing SNMP walk for data @ &#39;.1.3.6.1.2.1.2.2.1.1&#39;
+ Found item [ifIndex=&#39;1&#39;] index: 1 [from value]
+ Found item [ifIndex=&#39;2&#39;] index: 2 [from value]
</code></pre>
<h2 id="snmp-index-is-a-string">SNMP Index is a STRING</h2>
<p>Some devices (like on a F5 BigIP) use a STRING to represent the Index due to the fact it is user configurable. In this case we need Cacti to parse out the variable length Index.</p>
<p>Sample of a STRING Index:</p>
<p>Raw OID:</p>
<pre class="console"><code>.1.3.6.1.4.1.3375.2.2.10.2.3.1.1.5.76.88.87.69.66 = STRING: &quot;LXWEB&quot;
.1.3.6.1.4.1.3375.2.2.10.2.3.1.1.6.69.80.88.87.69.66 = STRING: &quot;EPXWEB&quot;
</code></pre>
<p>Textual MIB names:</p>
<pre class="console"><code>F5-BIGIP-LOCAL-MIB::ltmVirtualServStatName.&quot;LXWEB&quot; = STRING: LXWEB
F5-BIGIP-LOCAL-MIB::ltmVirtualServStatName.&quot;EPXWEB&quot; = STRING: EPXWEB
</code></pre>
<p>Next we need to define a OID/REGEXP that will look for the start of the STRING and create the Index. In this case the regexp "^.{32}" matches the first 32 characters beginning at the start of the OID -- this is the length of the OID from the leading dot up to the start of the index. Then the capturing parens "(.*)" grab the remainder of the OID as a backreference. Use the following SNMP XML script:</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode XML"><code class="sourceCode xml"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">&lt;interface&gt;</span></a>
<a class="sourceLine" id="cb7-2" title="2">    <span class="kw">&lt;name&gt;</span>Get F5 Big-IP Load Balancer Virtual Server Statistics<span class="kw">&lt;/name&gt;</span></a>
<a class="sourceLine" id="cb7-3" title="3">    <span class="kw">&lt;oid_index&gt;</span>.1.3.6.1.4.1.3375.2.2.10.2.3.1.1<span class="kw">&lt;/oid_index&gt;</span></a>
<a class="sourceLine" id="cb7-4" title="4">        <span class="kw">&lt;oid_index_parse&gt;</span>OID/REGEXP:^.{32}(.*)<span class="kw">&lt;/oid_index_parse&gt;</span></a>
<a class="sourceLine" id="cb7-5" title="5">        <span class="kw">&lt;index_order&gt;</span>vsIndex<span class="kw">&lt;/index_order&gt;</span></a>
<a class="sourceLine" id="cb7-6" title="6">        <span class="kw">&lt;index_order_type&gt;</span>alphabetic<span class="kw">&lt;/index_order_type&gt;</span></a>
<a class="sourceLine" id="cb7-7" title="7"></a>
<a class="sourceLine" id="cb7-8" title="8">        <span class="kw">&lt;fields&gt;</span></a>
<a class="sourceLine" id="cb7-9" title="9">        <span class="kw">&lt;vsIndex&gt;</span></a>
<a class="sourceLine" id="cb7-10" title="10">            <span class="kw">&lt;name&gt;</span>Index<span class="kw">&lt;/name&gt;</span></a>
<a class="sourceLine" id="cb7-11" title="11">            <span class="kw">&lt;source&gt;</span>index<span class="kw">&lt;/source&gt;</span></a>
<a class="sourceLine" id="cb7-12" title="12">            <span class="kw">&lt;direction&gt;</span>input<span class="kw">&lt;/direction&gt;</span></a>
<a class="sourceLine" id="cb7-13" title="13">        <span class="kw">&lt;/vsIndex&gt;</span></a>
<a class="sourceLine" id="cb7-14" title="14">    <span class="kw">&lt;/fields&gt;</span></a>
<a class="sourceLine" id="cb7-15" title="15"><span class="kw">&lt;/interface&gt;</span></a></code></pre></div>
<p>After creating the Data Query Data &amp; Graph templates in Cacti a verbose query will spit out the following:</p>
<pre class="shell"><code>+ Running data query [20].
+ Found type = &#39;3&#39; [snmp query].
+ Found data query XML file at &#39;C:/Inetpub/wwwroot/cacti/resource/snmp_queries/f5_bigip_vs.xml&#39;
+ XML file parsed ok.
+ Executing SNMP walk for list of indexes @ &#39;.1.3.6.1.4.1.3375.2.2.10.2.3.1.1&#39;
+ Index found at OID: &#39;enterprises.3375.2.2.10.2.3.1.1.5.76.88.87.69.66&#39; value: &#39;LXWEB&#39;
+ Index found at OID: &#39;enterprises.3375.2.2.10.2.3.1.1.6.69.80.88.87.69.66&#39; value: &#39;EPXWEB&#39;
+ index_parse at OID: &#39;enterprises.3375.2.2.10.2.3.1.1.5.76.88.87.69.66&#39; results: &#39;5.76.88.87.69.66&#39;
+ index_parse at OID: &#39;enterprises.3375.2.2.10.2.3.1.1.6.69.80.88.87.69.66&#39; results: &#39;6.69.80.88.87.69.66&#39;
+ Inserting index data for field &#39;vsIndex&#39; [value=&#39;5.76.88.87.69.66&#39;]
+ Inserting index data for field &#39;vsIndex&#39; [value=&#39;6.69.80.88.87.69.66&#39;]
</code></pre>
<h2 id="snmp-index-does-not-exist">SNMP Index does not exist</h2>
<p>Some devices do not offer a traditional Index OID to query. Here we need to create/fake the index for Cacti. This is accomplished once again with a simple REGEX to split off the last OID (or middle, etc) to create the index for cacti.</p>
<p>SNMPWALK:</p>
<p>Raw OIDs:</p>
<pre class="console"><code>.1.3.6.1.2.1.7.1.0 = Counter32: 69367
.1.3.6.1.2.1.7.2.0 = Counter32: 11
.1.3.6.1.2.1.7.3.0 = Counter32: 0
.1.3.6.1.2.1.7.4.0 = Counter32: 64392
</code></pre>
<p>Textual MIB name:</p>
<pre class="console"><code>UDP-MIB::udpInDatagrams.0 = Counter32: 69458
UDP-MIB::udpNoPorts.0 = Counter32: 11
UDP-MIB::udpInErrors.0 = Counter32: 0
UDP-MIB::udpOutDatagrams.0 = Counter32: 64471
</code></pre>
<p>Consulting the MIB file for these OIDs, we know that the associated index will always be "0" for each OID. We'll want to split this off with the REGEX.</p>
<p>Create the following SNMP XML file:</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode XML"><code class="sourceCode xml"><a class="sourceLine" id="cb11-1" title="1"><span class="kw">&lt;interface&gt;</span></a>
<a class="sourceLine" id="cb11-2" title="2">    <span class="kw">&lt;name&gt;</span>Get RFC1213 Stats<span class="kw">&lt;/name&gt;</span></a>
<a class="sourceLine" id="cb11-3" title="3">    <span class="kw">&lt;description&gt;</span>Management Information Base for Network Management of TCP/IP-based internets<span class="kw">&lt;/description&gt;</span></a>
<a class="sourceLine" id="cb11-4" title="4">    <span class="kw">&lt;oid_index&gt;</span>.1.3.6.1.2.1.7.2<span class="kw">&lt;/oid_index&gt;</span></a>
<a class="sourceLine" id="cb11-5" title="5">    <span class="kw">&lt;oid_index_parse&gt;</span>OID/REGEXP:.*\.([0-9]{1,2})$<span class="kw">&lt;/oid_index_parse&gt;</span></a>
<a class="sourceLine" id="cb11-6" title="6">    <span class="kw">&lt;index_order&gt;</span>Index<span class="kw">&lt;/index_order&gt;</span></a>
<a class="sourceLine" id="cb11-7" title="7">    <span class="kw">&lt;index_order_type&gt;</span>alphabetic<span class="kw">&lt;/index_order_type&gt;</span></a>
<a class="sourceLine" id="cb11-8" title="8"></a>
<a class="sourceLine" id="cb11-9" title="9">    <span class="kw">&lt;fields&gt;</span></a>
<a class="sourceLine" id="cb11-10" title="10">        <span class="kw">&lt;Index&gt;</span></a>
<a class="sourceLine" id="cb11-11" title="11">            <span class="kw">&lt;name&gt;</span>Index<span class="kw">&lt;/name&gt;</span></a>
<a class="sourceLine" id="cb11-12" title="12">            <span class="kw">&lt;source&gt;</span>index<span class="kw">&lt;/source&gt;</span></a>
<a class="sourceLine" id="cb11-13" title="13">            <span class="kw">&lt;direction&gt;</span>input<span class="kw">&lt;/direction&gt;</span></a>
<a class="sourceLine" id="cb11-14" title="14">        <span class="kw">&lt;/Index&gt;</span></a>
<a class="sourceLine" id="cb11-15" title="15">    <span class="kw">&lt;/fields&gt;</span></a>
<a class="sourceLine" id="cb11-16" title="16"><span class="kw">&lt;/interface&gt;</span></a></code></pre></div>
<p>Once all of the required templates have been created, a verbose query from Cacti results in the following:</p>
<pre class="shell"><code>+ Running data query [23].
+ Found type = &#39;3&#39; [snmp query].
+ Found data query XML file at &#39;C:/Inetpub/wwwroot/cacti/resource/snmp_queries/RFC1213.xml&#39;
+ XML file parsed ok.
+ Executing SNMP walk for list of indexes @ &#39;.1.3.6.1.2.1.7.2&#39;
+ Index found at OID: &#39;iso.3.6.1.2.1.7.2.0&#39; value: &#39;11&#39;
+ index_parse at OID: &#39;iso.3.6.1.2.1.7.2.0&#39; results: &#39;0&#39;
+ Inserting index data for field &#39;Index&#39; [value=&#39;0&#39;]
</code></pre>
<h2 id="a-note-on-textual-snmp-mibs-and-spine">A note on Textual SNMP MIBS and SPINE</h2>
<p>Please be aware the SPINE does not parse out textual Mibs. This means that if you were to use an OID that contained a string reference rather than numerical this will cause Graphs to fail as they will not be generated due to spine not reciving a value at each poll</p>
<p>Example of a bad OID reference for spine:</p>
<pre class="shell"><code>interfaces.mib.1.1.1.1.1
</code></pre>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
